/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { Autodesk.Revit.UI.Result returnCode = Autodesk.Revit.UI.Result.Cancelled; Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "Initialize Command"); tran.Start(); try { // one instance of DoorSwingData class. DoorSwingData databuffer = new DoorSwingData(commandData.Application); using (InitializeForm initForm = new InitializeForm(databuffer)) { // Show UI DialogResult dialogResult = initForm.ShowDialog(); if (DialogResult.OK == dialogResult) { databuffer.DeleteTempDoorInstances(); // update door type's opening feature based on family's actual geometry and // country's standard. databuffer.UpdateDoorFamiliesOpeningFeature(); // update each door instance's Opening feature and internal door flag returnCode = DoorSwingData.UpdateDoorsInfo(commandData.Application.ActiveUIDocument.Document, false, true, ref message); } } } catch (Exception ex) { // if there is anything wrong, give error information and return failed. message = ex.Message; returnCode = Autodesk.Revit.UI.Result.Failed; } if (Autodesk.Revit.UI.Result.Succeeded == returnCode) { tran.Commit(); } else { tran.RollBack(); } return(returnCode); }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, ElementSet elements) { Autodesk.Revit.UI.Result returnCode = Autodesk.Revit.UI.Result.Cancelled; Transaction tran = new Transaction(commandData.Application.ActiveUIDocument.Document, "Initialize Command"); tran.Start(); try { // one instance of DoorSwingData class. DoorSwingData databuffer = new DoorSwingData(commandData.Application); using (InitializeForm initForm = new InitializeForm(databuffer)) { // Show UI DialogResult dialogResult = initForm.ShowDialog(); if (DialogResult.OK == dialogResult) { databuffer.DeleteTempDoorInstances(); // update door type's opening feature based on family's actual geometry and // country's standard. databuffer.UpdateDoorFamiliesOpeningFeature(); // update each door instance's Opening feature and internal door flag returnCode = DoorSwingData.UpdateDoorsInfo(commandData.Application.ActiveUIDocument.Document, false, true, ref message); } } } catch (Exception ex) { // if there is anything wrong, give error information and return failed. message = ex.Message; returnCode = Autodesk.Revit.UI.Result.Failed; } if (Autodesk.Revit.UI.Result.Succeeded == returnCode) { tran.Commit(); } else { tran.RollBack(); } return returnCode; }
/// <summary> /// constructor overload. /// </summary> /// <param name="dataBuffer"> one reference of DoorSwingData.</param> public InitializeForm(DoorSwingData dataBuffer) : this() { m_dataBuffer = dataBuffer; // set data source of customizeDoorOpeningDataGridView. customizeDoorOpeningDataGridView.AutoGenerateColumns = false; customizeDoorOpeningDataGridView.DataSource = m_dataBuffer.DoorFamilies; familyNameColumn.DataPropertyName = "FamilyName"; OpeningColumn.DataPropertyName = "BasalOpeningValue"; OpeningColumn.DataSource = DoorSwingData.OpeningTypes; customizeDoorOpeningDataGridView.Focus(); if (customizeDoorOpeningDataGridView.Rows.Count != 0) { customizeDoorOpeningDataGridView.Rows[0].Selected = true; } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Autodesk.Revit.UI.Result returnCode = Autodesk.Revit.UI.Result.Succeeded; Autodesk.Revit.UI.UIApplication app = commandData.Application; UIDocument doc = app.ActiveUIDocument; Transaction tran = new Transaction(doc.Document, "Update Geometry Command"); tran.Start(); try { ElementSet elementSet = new ElementSet(); foreach (ElementId elementId in doc.Selection.GetElementIds()) { elementSet.Insert(doc.Document.GetElement(elementId)); } if (elementSet.IsEmpty) { DoorSwingData.UpdateDoorsGeometry(doc.Document, false); } else { DoorSwingData.UpdateDoorsGeometry(doc.Document, true); } returnCode = Autodesk.Revit.UI.Result.Succeeded; } catch (Exception ex) { // if there is anything wrong, give error information and return failed. message = ex.Message; returnCode = Autodesk.Revit.UI.Result.Failed; } if (Autodesk.Revit.UI.Result.Succeeded == returnCode) { tran.Commit(); } else { tran.RollBack(); } return(returnCode); }
/// <summary> /// This event is fired whenever a document is saved as. /// Update door's information according to door's current geometry. /// </summary> /// <param name="sender">The source of the event.</param> /// <param name="args">An DocumentSavingAsEventArgs that contains the DocumentSavingAs event data.</param> private void DocumentSavingAsHandler(Object sender, DocumentSavingAsEventArgs args) { string message = ""; Transaction tran = null; try { Document doc = args.Document; if (doc.IsModifiable) { if (DoorSwingData.UpdateDoorsInfo(args.Document, false, false, ref message) != Autodesk.Revit.UI.Result.Succeeded) { TaskDialog.Show("Door Swing", message); } } else { tran = new Transaction(doc, "Update parameters in Saving event"); tran.Start(); if (DoorSwingData.UpdateDoorsInfo(args.Document, false, false, ref message) != Autodesk.Revit.UI.Result.Succeeded) { TaskDialog.Show("Door Swing", message); } tran.Commit(); } } catch (Exception ex) { // if there are something wrong, give error message. TaskDialog.Show("Door Swing", ex.Message); if (null != tran) { if (tran.HasStarted() && !tran.HasEnded()) { tran.RollBack(); } } } }
/// <summary> /// Implement this method as an external command for Revit. /// </summary> /// <param name="commandData">An object that is passed to the external application /// which contains data related to the command, /// such as the application object and active view.</param> /// <param name="message">A message that can be set by the external application /// which will be displayed if a failure or cancellation is returned by /// the external command.</param> /// <param name="elements">A set of elements to which the external application /// can add elements that are to be highlighted in case of failure or cancellation.</param> /// <returns>Return the status of the external command. /// A result of Succeeded means that the API external method functioned as expected. /// Cancelled can be used to signify that the user cancelled the external operation /// at some point. Failure should be returned if the application is unable to proceed with /// the operation.</returns> public Autodesk.Revit.UI.Result Execute(ExternalCommandData commandData, ref string message, Autodesk.Revit.DB.ElementSet elements) { Autodesk.Revit.UI.Result returnCode = Autodesk.Revit.UI.Result.Succeeded; Autodesk.Revit.UI.UIApplication app = commandData.Application; UIDocument doc = app.ActiveUIDocument; Transaction tran = new Transaction(doc.Document, "Update Parameters Command"); tran.Start(); try { if (doc.Selection.Elements.IsEmpty) { returnCode = DoorSwingData.UpdateDoorsInfo(doc.Document, false, true, ref message); } else { returnCode = DoorSwingData.UpdateDoorsInfo(doc.Document, true, true, ref message); } } catch (Exception ex) { // if there is anything wrong, give error information and return failed. message = ex.Message; returnCode = Autodesk.Revit.UI.Result.Failed; } if (Autodesk.Revit.UI.Result.Succeeded == returnCode) { tran.Commit(); } else { tran.RollBack(); } return(returnCode); }